VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CFileAccess"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Dim fso As New FileSystemObject

Public Function readFile(filePath As String) As String
    Dim ts As TextStream
    Dim msg As String
    On Error GoTo reportError
    Set ts = fso.OpenTextFile(filePath, ForReading, False)
    readFile = ts.ReadAll
    ts.Close
    Exit Function
reportError:
    msg = "Error Occurred:" + vbCrLf
    msg = msg + Err.Description
    readFile = msg
    On Error GoTo 0
End Function

Public Function saveXML(filePath As String, xmlNode As Variant) As String
    Dim tempDoc As New DOMDocument
    Dim node As IXMLDOMNode
    Dim msg As String
    Dim txt As String
    On Error GoTo reportError
    If TypeName(xmlNode) = "DOMDocument" Then
        Set tempDoc = xmlNode
    Else
        Set node = xmlNode(0).cloneNode(True)
        tempDoc.loadXML node.xml
    End If
    tempDoc.save filePath
    Debug.Print filePath
    saveXML = ""
    Exit Function
reportError:
    msg = "Error Occurred:" + vbCrLf
    msg = msg + Err.Description
    saveXML = msg
    On Error GoTo 0
End Function

Public Function loadXML(filePath As String) As IXMLDOMElement
    Dim msg As String
    Dim xmlDoc As New FreeThreadedDOMDocument
    On Error GoTo reportError
    xmlDoc.async = False
    xmlDoc.Load filePath
    Set loadXML = xmlDoc.selectSingleNode("*")
    Exit Function
reportError:
    msg = "Error Occurred:" + vbCrLf
    msg = msg + Err.Description
    xmlDoc.loadXML "<error>" + msg + "</error>"
    xmlDoc.selectNodes ("*")
    On Error GoTo 0
End Function

Public Function writeFile(filePath As String, contents As Variant) As String
    Dim ts As TextStream
    Dim msg As String
    Dim output As String
    On Error GoTo reportError
    If TypeName(contents) <> "String" Then
        output = contents.Text
    Else
        output = contents
    End If
    Set ts = fso.OpenTextFile(filePath, ForWriting, True)
    ts.Write output
    ts.Close
    writeFile = ""
    Exit Function
reportError:
    msg = "Error Occurred:" + vbCrLf
    msg = msg + Err.Description
    writeFile = msg
    On Error GoTo 0
End Function


