<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
	xmlns:vb="http://www.microsoft.com/vb">
	<xsl:output method="xml"/>
	<xsl:template match="/">
		<xmp>
		<tvwnodes>
			<xsl:apply-templates select="*"/>
		</tvwnodes>
		</xmp>
	</xsl:template>
	
	<xsl:template match="*">
		<xsl:param name="ancestor_key"/>
		<xsl:param name="display" select="'yes'"/>
		<xsl:variable name="key" select="generate-id()"/>
		<tvwnode>
		<xsl:attribute name="display"><xsl:value-of select="$display"/></xsl:attribute>
		<xsl:attribute name="key"><xsl:value-of select="$key"/></xsl:attribute>
		<xsl:choose>
			<xsl:when test="parent::*">
				<xsl:attribute name="relation">4</xsl:attribute>
				<xsl:attribute name="relative"><xsl:value-of select="$ancestor_key"/></xsl:attribute>
			</xsl:when>
			<xsl:otherwise>
				<xsl:attribute name="relation">0</xsl:attribute>
				<xsl:attribute name="relative"><xsl:value-of select="$key"/></xsl:attribute>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:choose>
			<xsl:when test="text()">
				<xsl:attribute name="title"><xsl:value-of select="concat('&lt;',name(.),'&gt;',text())"/></xsl:attribute>				
			</xsl:when>
			<xsl:otherwise>
				<xsl:attribute name="title"><xsl:value-of select="concat('&lt;',name(.),'&gt;')"/></xsl:attribute>				
			</xsl:otherwise>
		</xsl:choose>
		</tvwnode>
		<xsl:apply-templates select="*">
			<xsl:with-param name="ancestor_key" select="$key"/>
			<xsl:with-param name="display" select="$display"/>
		</xsl:apply-templates>
	</xsl:template>
	
</xsl:stylesheet>